// Switcher
// Copyright (c) 1999 Nexus Software
// Created by Stas Maximov
// All rights reserved

#include <Application.h>
#include <Alert.h>
#include <String.h>
#include <FindDirectory.h>
#include <Deskbar.h>
#include <OS.h>
#include <Roster.h>
#include <stdlib.h>
#include <stdio.h>

#include "Main.h"
#include "SettingsWindow.h"
#include "DeskView.h"
#include "TextFile.h"
//#include "DebugClient.h"
#include "Version.h"

const char *app_signature = "application/x-vnd.Switcher";
//char REPLICANT_NAME[64];
//char version[32];

#define USER_BOOT_SCRIPT

// version info
const char *version_date = "Thursday, 12 July 2001";

// hot-keys
const int32	KEY_LCTRL_SHIFT = 0x2000;
const int32	KEY_OPT_SHIFT = 0x2001;
const int32	KEY_ALT_SHIFT = 0x2002;
const int32	KEY_SHIFT_SHIFT = 0x2003;

int main(int argc, char *argv[])  {
//	InitVersionInfo();
	for(int i=0; i<argc; i++) {
/*		if(0 == strcmp(argv[i], "--unload")) {
			BDeskbar *deskbar = new BDeskbar();
			deskbar->RemoveItem(REPLICANT_NAME);
			deskbar->RemoveItem("Switcher on Deskbar"); // remove very old one now
			return 0;
		} else
*/
		if(0 == strcmp(argv[i], "--addboot")) {
			BPath path;
			find_directory (B_USER_BOOT_DIRECTORY, &path);	
			BPath new_path = path;
			new_path.Append("UserBootscript.Switcher");
			path.Append("UserBootscript");

			bool bootscript_exists = false;
			KTextFile old_file(path.Path(), B_READ_WRITE);
			if (B_OK == old_file.InitCheck())
				bootscript_exists = true;
			
			KTextFile new_file(new_path.Path(), B_CREATE_FILE|B_READ_WRITE);
			BString str;
			status_t status = B_OK;
			while(status == B_OK && bootscript_exists) {
				status = old_file.ReadString(&str);
				if(B_ERROR == status)
					break;
				int32 app_pos = str.FindFirst("Indicator");
				int32 comment_pos = str.FindFirst("#");
				if((-1 !=  app_pos) && ((-1 == comment_pos) || (comment_pos>app_pos))) 
					str.Prepend("# ");
				new_file.WriteString(&str);
			}
			BString app_path = argv[0];
			app_path.Append(" &");
			new_file.WriteString(&app_path);
			BEntry entry(new_path.Path());
			entry.Rename(path.Path(), true);
			return 0;
		}
	}
	// no valid parameters supplied, just get added to Deskbar's shelf		
	BApplication app(app_signature);
	BDeskbar *deskbar = new BDeskbar();
	if (!deskbar->HasItem(REPLICANT_NAME)) {
		deskbar->AddItem(new DeskView(REPLICANT_NAME));
	}
	// commit suicide
	app.PostMessage(B_QUIT_REQUESTED);
	return B_OK;
}


/*bool version_info_initialized = false; // global flag

void InitVersionInfo() {
	if (!version_info_initialized) { 
		version_info_initialized = true;
//		BResources *res = BApplication::AppResources();
		strcpy(version, "1.0.3");
		strcpy(REPLICANT_NAME, "Switcher/Deskbar");
	}
}
*/
// About window
void ShowAboutWindow()  {
	BString str =  "Switcher" B_UTF8_TRADEMARK " -- switches system keymaps easily\n\n"
              "Version ";
           str += VERSION;
           str += "\nReleased on ";
           str += version_date;
           str += "\n\n"
           	"Copyright " B_UTF8_COPYRIGHT " 1999-2001 Stas Maximov\n"
              	"All Rights Reserved\n\n"
              	"nexus@benews.ru\n"
              	"http://www.benews.ru\n\n"
              	"Tested by Maxim Bazarov, Sergey Dolgov, Denis Korotkov, Nur Nazmetdinov and others listed in Bugs.txt\n"
              	"Special thanks to Pierre Raynaud-Richard and Robert Polic";
	(new BAlert(0, 
		str.String(),
              	"Okay",
              	0,
              	0,
              	B_WIDTH_AS_USUAL,
              	B_IDEA_ALERT))->Go(); 
}
